tests: explicitly use `git.exe` on Windows
[git/git.git] / t / test-lib-functions.sh
1 # Library of functions shared by all tests scripts, included by
2 # test-lib.sh.
3 #
4 # Copyright (c) 2005 Junio C Hamano
5 #
6 # This program is free software: you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation, either version 2 of the License, or
9 # (at your option) any later version.
10 #
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 # GNU General Public License for more details.
15 #
16 # You should have received a copy of the GNU General Public License
17 # along with this program. If not, see http://www.gnu.org/licenses/ .
18
19 # The semantics of the editor variables are that of invoking
20 # sh -c "$EDITOR \"$@\"" files ...
21 #
22 # If our trash directory contains shell metacharacters, they will be
23 # interpreted if we just set $EDITOR directly, so do a little dance with
24 # environment variables to work around this.
25 #
26 # In particular, quoting isn't enough, as the path may contain the same quote
27 # that we're using.
28 test_set_editor () {
29 FAKE_EDITOR="$1"
30 export FAKE_EDITOR
31 EDITOR='"$FAKE_EDITOR"'
32 export EDITOR
33 }
34
35 test_set_index_version () {
36 GIT_INDEX_VERSION="$1"
37 export GIT_INDEX_VERSION
38 }
39
40 test_decode_color () {
41 awk '
42 function name(n) {
43 if (n == 0) return "RESET";
44 if (n == 1) return "BOLD";
45 if (n == 2) return "FAINT";
46 if (n == 3) return "ITALIC";
47 if (n == 7) return "REVERSE";
48 if (n == 30) return "BLACK";
49 if (n == 31) return "RED";
50 if (n == 32) return "GREEN";
51 if (n == 33) return "YELLOW";
52 if (n == 34) return "BLUE";
53 if (n == 35) return "MAGENTA";
54 if (n == 36) return "CYAN";
55 if (n == 37) return "WHITE";
56 if (n == 40) return "BLACK";
57 if (n == 41) return "BRED";
58 if (n == 42) return "BGREEN";
59 if (n == 43) return "BYELLOW";
60 if (n == 44) return "BBLUE";
61 if (n == 45) return "BMAGENTA";
62 if (n == 46) return "BCYAN";
63 if (n == 47) return "BWHITE";
64 }
65 {
66 while (match($0, /\033\[[0-9;]*m/) != 0) {
67 printf "%s<", substr($0, 1, RSTART-1);
68 codes = substr($0, RSTART+2, RLENGTH-3);
69 if (length(codes) == 0)
70 printf "%s", name(0)
71 else {
72 n = split(codes, ary, ";");
73 sep = "";
74 for (i = 1; i <= n; i++) {
75 printf "%s%s", sep, name(ary[i]);
76 sep = ";"
77 }
78 }
79 printf ">";
80 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
81 }
82 print
83 }
84 '
85 }
86
87 lf_to_nul () {
88 perl -pe 'y/\012/\000/'
89 }
90
91 nul_to_q () {
92 perl -pe 'y/\000/Q/'
93 }
94
95 q_to_nul () {
96 perl -pe 'y/Q/\000/'
97 }
98
99 q_to_cr () {
100 tr Q '\015'
101 }
102
103 q_to_tab () {
104 tr Q '\011'
105 }
106
107 qz_to_tab_space () {
108 tr QZ '\011\040'
109 }
110
111 append_cr () {
112 sed -e 's/$/Q/' | tr Q '\015'
113 }
114
115 remove_cr () {
116 tr '\015' Q | sed -e 's/Q$//'
117 }
118
119 # In some bourne shell implementations, the "unset" builtin returns
120 # nonzero status when a variable to be unset was not set in the first
121 # place.
122 #
123 # Use sane_unset when that should not be considered an error.
124
125 sane_unset () {
126 unset "$@"
127 return 0
128 }
129
130 test_tick () {
131 if test -z "${test_tick+set}"
132 then
133 test_tick=1112911993
134 else
135 test_tick=$(($test_tick + 60))
136 fi
137 GIT_COMMITTER_DATE="$test_tick -0700"
138 GIT_AUTHOR_DATE="$test_tick -0700"
139 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
140 }
141
142 # Stop execution and start a shell. This is useful for debugging tests.
143 #
144 # Be sure to remove all invocations of this command before submitting.
145
146 test_pause () {
147 "$SHELL_PATH" <&6 >&5 2>&7
148 }
149
150 # Wrap git with a debugger. Adding this to a command can make it easier
151 # to understand what is going on in a failing test.
152 #
153 # Examples:
154 # debug git checkout master
155 # debug --debugger=nemiver git $ARGS
156 # debug -d "valgrind --tool=memcheck --track-origins=yes" git $ARGS
157 debug () {
158 case "$1" in
159 -d)
160 GIT_DEBUGGER="$2" &&
161 shift 2
162 ;;
163 --debugger=*)
164 GIT_DEBUGGER="${1#*=}" &&
165 shift 1
166 ;;
167 *)
168 GIT_DEBUGGER=1
169 ;;
170 esac &&
171 GIT_DEBUGGER="${GIT_DEBUGGER}" "$@" <&6 >&5 2>&7
172 }
173
174 # Call test_commit with the arguments
175 # [-C <directory>] <message> [<file> [<contents> [<tag>]]]"
176 #
177 # This will commit a file with the given contents and the given commit
178 # message, and tag the resulting commit with the given tag name.
179 #
180 # <file>, <contents>, and <tag> all default to <message>.
181 #
182 # If the first argument is "-C", the second argument is used as a path for
183 # the git invocations.
184
185 test_commit () {
186 notick= &&
187 signoff= &&
188 indir= &&
189 while test $# != 0
190 do
191 case "$1" in
192 --notick)
193 notick=yes
194 ;;
195 --signoff)
196 signoff="$1"
197 ;;
198 -C)
199 indir="$2"
200 shift
201 ;;
202 *)
203 break
204 ;;
205 esac
206 shift
207 done &&
208 indir=${indir:+"$indir"/} &&
209 file=${2:-"$1.t"} &&
210 echo "${3-$1}" > "$indir$file" &&
211 git ${indir:+ -C "$indir"} add "$file" &&
212 if test -z "$notick"
213 then
214 test_tick
215 fi &&
216 git ${indir:+ -C "$indir"} commit $signoff -m "$1" &&
217 git ${indir:+ -C "$indir"} tag "${4:-$1}"
218 }
219
220 # Call test_merge with the arguments "<message> <commit>", where <commit>
221 # can be a tag pointing to the commit-to-merge.
222
223 test_merge () {
224 test_tick &&
225 git merge -m "$1" "$2" &&
226 git tag "$1"
227 }
228
229 # This function helps systems where core.filemode=false is set.
230 # Use it instead of plain 'chmod +x' to set or unset the executable bit
231 # of a file in the working directory and add it to the index.
232
233 test_chmod () {
234 chmod "$@" &&
235 git update-index --add "--chmod=$@"
236 }
237
238 # Get the modebits from a file.
239 test_modebits () {
240 ls -l "$1" | sed -e 's|^\(..........\).*|\1|'
241 }
242
243 # Unset a configuration variable, but don't fail if it doesn't exist.
244 test_unconfig () {
245 config_dir=
246 if test "$1" = -C
247 then
248 shift
249 config_dir=$1
250 shift
251 fi
252 git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
253 config_status=$?
254 case "$config_status" in
255 5) # ok, nothing to unset
256 config_status=0
257 ;;
258 esac
259 return $config_status
260 }
261
262 # Set git config, automatically unsetting it after the test is over.
263 test_config () {
264 config_dir=
265 if test "$1" = -C
266 then
267 shift
268 config_dir=$1
269 shift
270 fi
271 test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
272 git ${config_dir:+-C "$config_dir"} config "$@"
273 }
274
275 test_config_global () {
276 test_when_finished "test_unconfig --global '$1'" &&
277 git config --global "$@"
278 }
279
280 write_script () {
281 {
282 echo "#!${2-"$SHELL_PATH"}" &&
283 cat
284 } >"$1" &&
285 chmod +x "$1"
286 }
287
288 # Use test_set_prereq to tell that a particular prerequisite is available.
289 # The prerequisite can later be checked for in two ways:
290 #
291 # - Explicitly using test_have_prereq.
292 #
293 # - Implicitly by specifying the prerequisite tag in the calls to
294 # test_expect_{success,failure,code}.
295 #
296 # The single parameter is the prerequisite tag (a simple word, in all
297 # capital letters by convention).
298
299 test_unset_prereq () {
300 ! test_have_prereq "$1" ||
301 satisfied_prereq="${satisfied_prereq% $1 *} ${satisfied_prereq#* $1 }"
302 }
303
304 test_set_prereq () {
305 case "$1" in
306 !*)
307 test_unset_prereq "${1#!}"
308 ;;
309 *)
310 satisfied_prereq="$satisfied_prereq$1 "
311 ;;
312 esac
313 }
314 satisfied_prereq=" "
315 lazily_testable_prereq= lazily_tested_prereq=
316
317 # Usage: test_lazy_prereq PREREQ 'script'
318 test_lazy_prereq () {
319 lazily_testable_prereq="$lazily_testable_prereq$1 "
320 eval test_prereq_lazily_$1=\$2
321 }
322
323 test_run_lazy_prereq_ () {
324 script='
325 mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
326 (
327 cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
328 )'
329 say >&3 "checking prerequisite: $1"
330 say >&3 "$script"
331 test_eval_ "$script"
332 eval_ret=$?
333 rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
334 if test "$eval_ret" = 0; then
335 say >&3 "prerequisite $1 ok"
336 else
337 say >&3 "prerequisite $1 not satisfied"
338 fi
339 return $eval_ret
340 }
341
342 test_have_prereq () {
343 # prerequisites can be concatenated with ','
344 save_IFS=$IFS
345 IFS=,
346 set -- $*
347 IFS=$save_IFS
348
349 total_prereq=0
350 ok_prereq=0
351 missing_prereq=
352
353 for prerequisite
354 do
355 case "$prerequisite" in
356 !*)
357 negative_prereq=t
358 prerequisite=${prerequisite#!}
359 ;;
360 *)
361 negative_prereq=
362 esac
363
364 case " $lazily_tested_prereq " in
365 *" $prerequisite "*)
366 ;;
367 *)
368 case " $lazily_testable_prereq " in
369 *" $prerequisite "*)
370 eval "script=\$test_prereq_lazily_$prerequisite" &&
371 if test_run_lazy_prereq_ "$prerequisite" "$script"
372 then
373 test_set_prereq $prerequisite
374 fi
375 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
376 esac
377 ;;
378 esac
379
380 total_prereq=$(($total_prereq + 1))
381 case "$satisfied_prereq" in
382 *" $prerequisite "*)
383 satisfied_this_prereq=t
384 ;;
385 *)
386 satisfied_this_prereq=
387 esac
388
389 case "$satisfied_this_prereq,$negative_prereq" in
390 t,|,t)
391 ok_prereq=$(($ok_prereq + 1))
392 ;;
393 *)
394 # Keep a list of missing prerequisites; restore
395 # the negative marker if necessary.
396 prerequisite=${negative_prereq:+!}$prerequisite
397 if test -z "$missing_prereq"
398 then
399 missing_prereq=$prerequisite
400 else
401 missing_prereq="$prerequisite,$missing_prereq"
402 fi
403 esac
404 done
405
406 test $total_prereq = $ok_prereq
407 }
408
409 test_declared_prereq () {
410 case ",$test_prereq," in
411 *,$1,*)
412 return 0
413 ;;
414 esac
415 return 1
416 }
417
418 test_verify_prereq () {
419 test -z "$test_prereq" ||
420 expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
421 error "bug in the test script: '$test_prereq' does not look like a prereq"
422 }
423
424 test_expect_failure () {
425 test_start_
426 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
427 test "$#" = 2 ||
428 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
429 test_verify_prereq
430 export test_prereq
431 if ! test_skip "$@"
432 then
433 say >&3 "checking known breakage: $2"
434 if test_run_ "$2" expecting_failure
435 then
436 test_known_broken_ok_ "$1"
437 else
438 test_known_broken_failure_ "$1"
439 fi
440 fi
441 test_finish_
442 }
443
444 test_expect_success () {
445 test_start_
446 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
447 test "$#" = 2 ||
448 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
449 test_verify_prereq
450 export test_prereq
451 if ! test_skip "$@"
452 then
453 say >&3 "expecting success: $2"
454 if test_run_ "$2"
455 then
456 test_ok_ "$1"
457 else
458 test_failure_ "$@"
459 fi
460 fi
461 test_finish_
462 }
463
464 # test_external runs external test scripts that provide continuous
465 # test output about their progress, and succeeds/fails on
466 # zero/non-zero exit code. It outputs the test output on stdout even
467 # in non-verbose mode, and announces the external script with "# run
468 # <n>: ..." before running it. When providing relative paths, keep in
469 # mind that all scripts run in "trash directory".
470 # Usage: test_external description command arguments...
471 # Example: test_external 'Perl API' perl ../path/to/test.pl
472 test_external () {
473 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
474 test "$#" = 3 ||
475 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
476 descr="$1"
477 shift
478 test_verify_prereq
479 export test_prereq
480 if ! test_skip "$descr" "$@"
481 then
482 # Announce the script to reduce confusion about the
483 # test output that follows.
484 say_color "" "# run $test_count: $descr ($*)"
485 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
486 # to be able to use them in script
487 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
488 # Run command; redirect its stderr to &4 as in
489 # test_run_, but keep its stdout on our stdout even in
490 # non-verbose mode.
491 "$@" 2>&4
492 if test "$?" = 0
493 then
494 if test $test_external_has_tap -eq 0; then
495 test_ok_ "$descr"
496 else
497 say_color "" "# test_external test $descr was ok"
498 test_success=$(($test_success + 1))
499 fi
500 else
501 if test $test_external_has_tap -eq 0; then
502 test_failure_ "$descr" "$@"
503 else
504 say_color error "# test_external test $descr failed: $@"
505 test_failure=$(($test_failure + 1))
506 fi
507 fi
508 fi
509 }
510
511 # Like test_external, but in addition tests that the command generated
512 # no output on stderr.
513 test_external_without_stderr () {
514 # The temporary file has no (and must have no) security
515 # implications.
516 tmp=${TMPDIR:-/tmp}
517 stderr="$tmp/git-external-stderr.$$.tmp"
518 test_external "$@" 4> "$stderr"
519 test -f "$stderr" || error "Internal error: $stderr disappeared."
520 descr="no stderr: $1"
521 shift
522 say >&3 "# expecting no stderr from previous command"
523 if test ! -s "$stderr"
524 then
525 rm "$stderr"
526
527 if test $test_external_has_tap -eq 0; then
528 test_ok_ "$descr"
529 else
530 say_color "" "# test_external_without_stderr test $descr was ok"
531 test_success=$(($test_success + 1))
532 fi
533 else
534 if test "$verbose" = t
535 then
536 output=$(echo; echo "# Stderr is:"; cat "$stderr")
537 else
538 output=
539 fi
540 # rm first in case test_failure exits.
541 rm "$stderr"
542 if test $test_external_has_tap -eq 0; then
543 test_failure_ "$descr" "$@" "$output"
544 else
545 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
546 test_failure=$(($test_failure + 1))
547 fi
548 fi
549 }
550
551 # debugging-friendly alternatives to "test [-f|-d|-e]"
552 # The commands test the existence or non-existence of $1. $2 can be
553 # given to provide a more precise diagnosis.
554 test_path_is_file () {
555 if ! test -f "$1"
556 then
557 echo "File $1 doesn't exist. $2"
558 false
559 fi
560 }
561
562 test_path_is_dir () {
563 if ! test -d "$1"
564 then
565 echo "Directory $1 doesn't exist. $2"
566 false
567 fi
568 }
569
570 test_path_exists () {
571 if ! test -e "$1"
572 then
573 echo "Path $1 doesn't exist. $2"
574 false
575 fi
576 }
577
578 # Check if the directory exists and is empty as expected, barf otherwise.
579 test_dir_is_empty () {
580 test_path_is_dir "$1" &&
581 if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
582 then
583 echo "Directory '$1' is not empty, it contains:"
584 ls -la "$1"
585 return 1
586 fi
587 }
588
589 test_path_is_missing () {
590 if test -e "$1"
591 then
592 echo "Path exists:"
593 ls -ld "$1"
594 if test $# -ge 1
595 then
596 echo "$*"
597 fi
598 false
599 fi
600 }
601
602 # test_line_count checks that a file has the number of lines it
603 # ought to. For example:
604 #
605 # test_expect_success 'produce exactly one line of output' '
606 # do something >output &&
607 # test_line_count = 1 output
608 # '
609 #
610 # is like "test $(wc -l <output) = 1" except that it passes the
611 # output through when the number of lines is wrong.
612
613 test_line_count () {
614 if test $# != 3
615 then
616 error "bug in the test script: not 3 parameters to test_line_count"
617 elif ! test $(wc -l <"$3") "$1" "$2"
618 then
619 echo "test_line_count: line count for $3 !$1 $2"
620 cat "$3"
621 return 1
622 fi
623 }
624
625 # Returns success if a comma separated string of keywords ($1) contains a
626 # given keyword ($2).
627 # Examples:
628 # `list_contains "foo,bar" bar` returns 0
629 # `list_contains "foo" bar` returns 1
630
631 list_contains () {
632 case ",$1," in
633 *,$2,*)
634 return 0
635 ;;
636 esac
637 return 1
638 }
639
640 # This is not among top-level (test_expect_success | test_expect_failure)
641 # but is a prefix that can be used in the test script, like:
642 #
643 # test_expect_success 'complain and die' '
644 # do something &&
645 # do something else &&
646 # test_must_fail git checkout ../outerspace
647 # '
648 #
649 # Writing this as "! git checkout ../outerspace" is wrong, because
650 # the failure could be due to a segv. We want a controlled failure.
651 #
652 # Accepts the following options:
653 #
654 # ok=<signal-name>[,<...>]:
655 # Don't treat an exit caused by the given signal as error.
656 # Multiple signals can be specified as a comma separated list.
657 # Currently recognized signal names are: sigpipe, success.
658 # (Don't use 'success', use 'test_might_fail' instead.)
659
660 test_must_fail () {
661 case "$1" in
662 ok=*)
663 _test_ok=${1#ok=}
664 shift
665 ;;
666 *)
667 _test_ok=
668 ;;
669 esac
670 "$@" 2>&7
671 exit_code=$?
672 if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
673 then
674 echo >&4 "test_must_fail: command succeeded: $*"
675 return 1
676 elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
677 then
678 return 0
679 elif test $exit_code -gt 129 && test $exit_code -le 192
680 then
681 echo >&4 "test_must_fail: died by signal $(($exit_code - 128)): $*"
682 return 1
683 elif test $exit_code -eq 127
684 then
685 echo >&4 "test_must_fail: command not found: $*"
686 return 1
687 elif test $exit_code -eq 126
688 then
689 echo >&4 "test_must_fail: valgrind error: $*"
690 return 1
691 fi
692 return 0
693 } 7>&2 2>&4
694
695 # Similar to test_must_fail, but tolerates success, too. This is
696 # meant to be used in contexts like:
697 #
698 # test_expect_success 'some command works without configuration' '
699 # test_might_fail git config --unset all.configuration &&
700 # do something
701 # '
702 #
703 # Writing "git config --unset all.configuration || :" would be wrong,
704 # because we want to notice if it fails due to segv.
705 #
706 # Accepts the same options as test_must_fail.
707
708 test_might_fail () {
709 test_must_fail ok=success "$@" 2>&7
710 } 7>&2 2>&4
711
712 # Similar to test_must_fail and test_might_fail, but check that a
713 # given command exited with a given exit code. Meant to be used as:
714 #
715 # test_expect_success 'Merge with d/f conflicts' '
716 # test_expect_code 1 git merge "merge msg" B master
717 # '
718
719 test_expect_code () {
720 want_code=$1
721 shift
722 "$@" 2>&7
723 exit_code=$?
724 if test $exit_code = $want_code
725 then
726 return 0
727 fi
728
729 echo >&4 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
730 return 1
731 } 7>&2 2>&4
732
733 # test_cmp is a helper function to compare actual and expected output.
734 # You can use it like:
735 #
736 # test_expect_success 'foo works' '
737 # echo expected >expected &&
738 # foo >actual &&
739 # test_cmp expected actual
740 # '
741 #
742 # This could be written as either "cmp" or "diff -u", but:
743 # - cmp's output is not nearly as easy to read as diff -u
744 # - not all diff versions understand "-u"
745
746 test_cmp() {
747 $GIT_TEST_CMP "$@"
748 }
749
750 # Check that the given config key has the expected value.
751 #
752 # test_cmp_config [-C <dir>] <expected-value>
753 # [<git-config-options>...] <config-key>
754 #
755 # for example to check that the value of core.bar is foo
756 #
757 # test_cmp_config foo core.bar
758 #
759 test_cmp_config() {
760 local GD &&
761 if test "$1" = "-C"
762 then
763 shift &&
764 GD="-C $1" &&
765 shift
766 fi &&
767 printf "%s\n" "$1" >expect.config &&
768 shift &&
769 git $GD config "$@" >actual.config &&
770 test_cmp expect.config actual.config
771 }
772
773 # test_cmp_bin - helper to compare binary files
774
775 test_cmp_bin() {
776 cmp "$@"
777 }
778
779 # Use this instead of test_cmp to compare files that contain expected and
780 # actual output from git commands that can be translated. When running
781 # under GETTEXT_POISON this pretends that the command produced expected
782 # results.
783 test_i18ncmp () {
784 test -n "$GETTEXT_POISON" || test_cmp "$@"
785 }
786
787 # Use this instead of "grep expected-string actual" to see if the
788 # output from a git command that can be translated either contains an
789 # expected string, or does not contain an unwanted one. When running
790 # under GETTEXT_POISON this pretends that the command produced expected
791 # results.
792 test_i18ngrep () {
793 eval "last_arg=\${$#}"
794
795 test -f "$last_arg" ||
796 error "bug in the test script: test_i18ngrep requires a file" \
797 "to read as the last parameter"
798
799 if test $# -lt 2 ||
800 { test "x!" = "x$1" && test $# -lt 3 ; }
801 then
802 error "bug in the test script: too few parameters to test_i18ngrep"
803 fi
804
805 if test -n "$GETTEXT_POISON"
806 then
807 # pretend success
808 return 0
809 fi
810
811 if test "x!" = "x$1"
812 then
813 shift
814 ! grep "$@" && return 0
815
816 echo >&4 "error: '! grep $@' did find a match in:"
817 else
818 grep "$@" && return 0
819
820 echo >&4 "error: 'grep $@' didn't find a match in:"
821 fi
822
823 if test -s "$last_arg"
824 then
825 cat >&4 "$last_arg"
826 else
827 echo >&4 "<File '$last_arg' is empty>"
828 fi
829
830 return 1
831 }
832
833 # Call any command "$@" but be more verbose about its
834 # failure. This is handy for commands like "test" which do
835 # not output anything when they fail.
836 verbose () {
837 "$@" && return 0
838 echo >&4 "command failed: $(git rev-parse --sq-quote "$@")"
839 return 1
840 }
841
842 # Check if the file expected to be empty is indeed empty, and barfs
843 # otherwise.
844
845 test_must_be_empty () {
846 test_path_is_file "$1" &&
847 if test -s "$1"
848 then
849 echo "'$1' is not empty, it contains:"
850 cat "$1"
851 return 1
852 fi
853 }
854
855 # Tests that its two parameters refer to the same revision
856 test_cmp_rev () {
857 git rev-parse --verify "$1" >expect.rev &&
858 git rev-parse --verify "$2" >actual.rev &&
859 test_cmp expect.rev actual.rev
860 }
861
862 # Print a sequence of integers in increasing order, either with
863 # two arguments (start and end):
864 #
865 # test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
866 #
867 # or with one argument (end), in which case it starts counting
868 # from 1.
869
870 test_seq () {
871 case $# in
872 1) set 1 "$@" ;;
873 2) ;;
874 *) error "bug in the test script: not 1 or 2 parameters to test_seq" ;;
875 esac
876 test_seq_counter__=$1
877 while test "$test_seq_counter__" -le "$2"
878 do
879 echo "$test_seq_counter__"
880 test_seq_counter__=$(( $test_seq_counter__ + 1 ))
881 done
882 }
883
884 # This function can be used to schedule some commands to be run
885 # unconditionally at the end of the test to restore sanity:
886 #
887 # test_expect_success 'test core.capslock' '
888 # git config core.capslock true &&
889 # test_when_finished "git config --unset core.capslock" &&
890 # hello world
891 # '
892 #
893 # That would be roughly equivalent to
894 #
895 # test_expect_success 'test core.capslock' '
896 # git config core.capslock true &&
897 # hello world
898 # git config --unset core.capslock
899 # '
900 #
901 # except that the greeting and config --unset must both succeed for
902 # the test to pass.
903 #
904 # Note that under --immediate mode, no clean-up is done to help diagnose
905 # what went wrong.
906
907 test_when_finished () {
908 # We cannot detect when we are in a subshell in general, but by
909 # doing so on Bash is better than nothing (the test will
910 # silently pass on other shells).
911 test "${BASH_SUBSHELL-0}" = 0 ||
912 error "bug in test script: test_when_finished does nothing in a subshell"
913 test_cleanup="{ $*
914 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
915 }
916
917 # Most tests can use the created repository, but some may need to create more.
918 # Usage: test_create_repo <directory>
919 test_create_repo () {
920 test "$#" = 1 ||
921 error "bug in the test script: not 1 parameter to test-create-repo"
922 repo="$1"
923 mkdir -p "$repo"
924 (
925 cd "$repo" || error "Cannot setup test environment"
926 "${GIT_TEST_INSTALLED:-$GIT_EXEC_PATH}/git$X" init \
927 "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
928 error "cannot run git init -- have you built things yet?"
929 mv .git/hooks .git/hooks-disabled
930 ) || exit
931 }
932
933 # This function helps on symlink challenged file systems when it is not
934 # important that the file system entry is a symbolic link.
935 # Use test_ln_s_add instead of "ln -s x y && git add y" to add a
936 # symbolic link entry y to the index.
937
938 test_ln_s_add () {
939 if test_have_prereq SYMLINKS
940 then
941 ln -s "$1" "$2" &&
942 git update-index --add "$2"
943 else
944 printf '%s' "$1" >"$2" &&
945 ln_s_obj=$(git hash-object -w "$2") &&
946 git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
947 # pick up stat info from the file
948 git update-index "$2"
949 fi
950 }
951
952 # This function writes out its parameters, one per line
953 test_write_lines () {
954 printf "%s\n" "$@"
955 }
956
957 perl () {
958 command "$PERL_PATH" "$@" 2>&7
959 } 7>&2 2>&4
960
961 # Is the value one of the various ways to spell a boolean true/false?
962 test_normalize_bool () {
963 git -c magic.variable="$1" config --bool magic.variable 2>/dev/null
964 }
965
966 # Given a variable $1, normalize the value of it to one of "true",
967 # "false", or "auto" and store the result to it.
968 #
969 # test_tristate GIT_TEST_HTTPD
970 #
971 # A variable set to an empty string is set to 'false'.
972 # A variable set to 'false' or 'auto' keeps its value.
973 # Anything else is set to 'true'.
974 # An unset variable defaults to 'auto'.
975 #
976 # The last rule is to allow people to set the variable to an empty
977 # string and export it to decline testing the particular feature
978 # for versions both before and after this change. We used to treat
979 # both unset and empty variable as a signal for "do not test" and
980 # took any non-empty string as "please test".
981
982 test_tristate () {
983 if eval "test x\"\${$1+isset}\" = xisset"
984 then
985 # explicitly set
986 eval "
987 case \"\$$1\" in
988 '') $1=false ;;
989 auto) ;;
990 *) $1=\$(test_normalize_bool \$$1 || echo true) ;;
991 esac
992 "
993 else
994 eval "$1=auto"
995 fi
996 }
997
998 # Exit the test suite, either by skipping all remaining tests or by
999 # exiting with an error. If "$1" is "auto", we then we assume we were
1000 # opportunistically trying to set up some tests and we skip. If it is
1001 # "true", then we report a failure.
1002 #
1003 # The error/skip message should be given by $2.
1004 #
1005 test_skip_or_die () {
1006 case "$1" in
1007 auto)
1008 skip_all=$2
1009 test_done
1010 ;;
1011 true)
1012 error "$2"
1013 ;;
1014 *)
1015 error "BUG: test tristate is '$1' (real error: $2)"
1016 esac
1017 }
1018
1019 # The following mingw_* functions obey POSIX shell syntax, but are actually
1020 # bash scripts, and are meant to be used only with bash on Windows.
1021
1022 # A test_cmp function that treats LF and CRLF equal and avoids to fork
1023 # diff when possible.
1024 mingw_test_cmp () {
1025 # Read text into shell variables and compare them. If the results
1026 # are different, use regular diff to report the difference.
1027 local test_cmp_a= test_cmp_b=
1028
1029 # When text came from stdin (one argument is '-') we must feed it
1030 # to diff.
1031 local stdin_for_diff=
1032
1033 # Since it is difficult to detect the difference between an
1034 # empty input file and a failure to read the files, we go straight
1035 # to diff if one of the inputs is empty.
1036 if test -s "$1" && test -s "$2"
1037 then
1038 # regular case: both files non-empty
1039 mingw_read_file_strip_cr_ test_cmp_a <"$1"
1040 mingw_read_file_strip_cr_ test_cmp_b <"$2"
1041 elif test -s "$1" && test "$2" = -
1042 then
1043 # read 2nd file from stdin
1044 mingw_read_file_strip_cr_ test_cmp_a <"$1"
1045 mingw_read_file_strip_cr_ test_cmp_b
1046 stdin_for_diff='<<<"$test_cmp_b"'
1047 elif test "$1" = - && test -s "$2"
1048 then
1049 # read 1st file from stdin
1050 mingw_read_file_strip_cr_ test_cmp_a
1051 mingw_read_file_strip_cr_ test_cmp_b <"$2"
1052 stdin_for_diff='<<<"$test_cmp_a"'
1053 fi
1054 test -n "$test_cmp_a" &&
1055 test -n "$test_cmp_b" &&
1056 test "$test_cmp_a" = "$test_cmp_b" ||
1057 eval "diff -u \"\$@\" $stdin_for_diff"
1058 }
1059
1060 # $1 is the name of the shell variable to fill in
1061 mingw_read_file_strip_cr_ () {
1062 # Read line-wise using LF as the line separator
1063 # and use IFS to strip CR.
1064 local line
1065 while :
1066 do
1067 if IFS=$'\r' read -r -d $'\n' line
1068 then
1069 # good
1070 line=$line$'\n'
1071 else
1072 # we get here at EOF, but also if the last line
1073 # was not terminated by LF; in the latter case,
1074 # some text was read
1075 if test -z "$line"
1076 then
1077 # EOF, really
1078 break
1079 fi
1080 fi
1081 eval "$1=\$$1\$line"
1082 done
1083 }
1084
1085 # Like "env FOO=BAR some-program", but run inside a subshell, which means
1086 # it also works for shell functions (though those functions cannot impact
1087 # the environment outside of the test_env invocation).
1088 test_env () {
1089 (
1090 while test $# -gt 0
1091 do
1092 case "$1" in
1093 *=*)
1094 eval "${1%%=*}=\${1#*=}"
1095 eval "export ${1%%=*}"
1096 shift
1097 ;;
1098 *)
1099 "$@" 2>&7
1100 exit
1101 ;;
1102 esac
1103 done
1104 )
1105 } 7>&2 2>&4
1106
1107 # Returns true if the numeric exit code in "$2" represents the expected signal
1108 # in "$1". Signals should be given numerically.
1109 test_match_signal () {
1110 if test "$2" = "$((128 + $1))"
1111 then
1112 # POSIX
1113 return 0
1114 elif test "$2" = "$((256 + $1))"
1115 then
1116 # ksh
1117 return 0
1118 fi
1119 return 1
1120 }
1121
1122 # Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
1123 test_copy_bytes () {
1124 perl -e '
1125 my $len = $ARGV[1];
1126 while ($len > 0) {
1127 my $s;
1128 my $nread = sysread(STDIN, $s, $len);
1129 die "cannot read: $!" unless defined($nread);
1130 last unless $nread;
1131 print $s;
1132 $len -= $nread;
1133 }
1134 ' - "$1"
1135 }
1136
1137 # run "$@" inside a non-git directory
1138 nongit () {
1139 test -d non-repo ||
1140 mkdir non-repo ||
1141 return 1
1142
1143 (
1144 GIT_CEILING_DIRECTORIES=$(pwd) &&
1145 export GIT_CEILING_DIRECTORIES &&
1146 cd non-repo &&
1147 "$@" 2>&7
1148 )
1149 } 7>&2 2>&4
1150
1151 # convert stdin to pktline representation; note that empty input becomes an
1152 # empty packet, not a flush packet (for that you can just print 0000 yourself).
1153 packetize() {
1154 cat >packetize.tmp &&
1155 len=$(wc -c <packetize.tmp) &&
1156 printf '%04x%s' "$(($len + 4))" &&
1157 cat packetize.tmp &&
1158 rm -f packetize.tmp
1159 }
1160
1161 # Parse the input as a series of pktlines, writing the result to stdout.
1162 # Sideband markers are removed automatically, and the output is routed to
1163 # stderr if appropriate.
1164 #
1165 # NUL bytes are converted to "\\0" for ease of parsing with text tools.
1166 depacketize () {
1167 perl -e '
1168 while (read(STDIN, $len, 4) == 4) {
1169 if ($len eq "0000") {
1170 print "FLUSH\n";
1171 } else {
1172 read(STDIN, $buf, hex($len) - 4);
1173 $buf =~ s/\0/\\0/g;
1174 if ($buf =~ s/^[\x2\x3]//) {
1175 print STDERR $buf;
1176 } else {
1177 $buf =~ s/^\x1//;
1178 print $buf;
1179 }
1180 }
1181 }
1182 '
1183 }
1184
1185 # Set the hash algorithm in use to $1. Only useful when testing the testsuite.
1186 test_set_hash () {
1187 test_hash_algo="$1"
1188 }
1189
1190 # Detect the hash algorithm in use.
1191 test_detect_hash () {
1192 # Currently we only support SHA-1, but in the future this function will
1193 # actually detect the algorithm in use.
1194 test_hash_algo='sha1'
1195 }
1196
1197 # Load common hash metadata and common placeholder object IDs for use with
1198 # test_oid.
1199 test_oid_init () {
1200 test -n "$test_hash_algo" || test_detect_hash &&
1201 test_oid_cache <"$TEST_DIRECTORY/oid-info/hash-info" &&
1202 test_oid_cache <"$TEST_DIRECTORY/oid-info/oid"
1203 }
1204
1205 # Load key-value pairs from stdin suitable for use with test_oid. Blank lines
1206 # and lines starting with "#" are ignored. Keys must be shell identifier
1207 # characters.
1208 #
1209 # Examples:
1210 # rawsz sha1:20
1211 # rawsz sha256:32
1212 test_oid_cache () {
1213 local tag rest k v &&
1214
1215 { test -n "$test_hash_algo" || test_detect_hash; } &&
1216 while read tag rest
1217 do
1218 case $tag in
1219 \#*)
1220 continue;;
1221 ?*)
1222 # non-empty
1223 ;;
1224 *)
1225 # blank line
1226 continue;;
1227 esac &&
1228
1229 k="${rest%:*}" &&
1230 v="${rest#*:}" &&
1231
1232 if ! expr "$k" : '[a-z0-9][a-z0-9]*$' >/dev/null
1233 then
1234 error 'bug in the test script: bad hash algorithm'
1235 fi &&
1236 eval "test_oid_${k}_$tag=\"\$v\""
1237 done
1238 }
1239
1240 # Look up a per-hash value based on a key ($1). The value must have been loaded
1241 # by test_oid_init or test_oid_cache.
1242 test_oid () {
1243 local var="test_oid_${test_hash_algo}_$1" &&
1244
1245 # If the variable is unset, we must be missing an entry for this
1246 # key-hash pair, so exit with an error.
1247 if eval "test -z \"\${$var+set}\""
1248 then
1249 error "bug in the test script: undefined key '$1'" >&2
1250 fi &&
1251 eval "printf '%s' \"\${$var}\""
1252 }